#!/bin/bash
# 
# Usage: resource-exporter [OPTIONS]
# 
# Options:
#       --listen_addr <LISTEN_ADDR>        Application listen address [default: 0.0.0.0:9100]
#       --allow_addr <ALLOW_ADDR>          Application allow address
#       --libvirt_ticker <LIBVIRT_TICKER>  Libvirt ticker [default: 3]
#       --libvirt_driver <LIBVIRT_DRIVER>  Libvirt driver [default: qemu]
#       --libvirt_user <LIBVIRT_USER>      Libvirt remote user [default: root]
#       --libvirt_addr <LIBVIRT_ADDR>      Libvirt remote addr [default: 127.0.0.1]
#       --libvirt_port <LIBVIRT_PORT>      Libvirt remote port [default: 16509]
#       --libvirt_path <LIBVIRT_PATH>      Libvirt remote path [default: system]
#   -h, --help                             Print help

liste_addr="0.0.0.0:9100"
allow_addr="192.168.188.73"
libvirt_driver="qemu"
old_proc=$(ps -ef | grep resource-exporter |awk /listen/'{print $2}')
 
# startup resource exporter
if [[ -z $old_proc ]];then
   cd `dirname $0` && ./resource-exporter --listen_addr $liste_addr --allow_addr $allow_addr --libvirt_driver $libvirt_driver &
else
    echo "Service is running"
fi
