#!/usr/bin/python3
# -*- coding: utf-8 -*-
import os
import time
import cs
import json


def client_cloudstack(api_url, api_key, secret_key):
    return cs.CloudStack(api_url, api_key, secret_key)


def file_exists_with_timeout(filepath, timeout=10):
    start_time = time.time()
    while time.time() - start_time < timeout:
        if not os.path.exists(filepath):
            os.mknod(filepath)
            return True
    return False


def get_cloudstack_virtual(client, hostid):
    req = client.listVirtualMachines(listall='true', details='servoff,tmpl,nics',
                                     hostid=hostid, page=1, pagesize=500)
    hostnames_to_check = []
    for virtuals in req.get('virtualmachine', []):
        # 获取内部名称
        virtual_instancename = virtuals.get('instancename', '')
        hostnames_to_check.append(virtual_instancename)

    # 文件路径
    file_path = '/opt/exporter/data/fdb'
    lock_path = file_path + '.lock'

    try:

        # 读取文件内容
        with open(file_path, 'r') as file:
            data = json.load(file)

        # 进行主机名比对
        keys_to_remove = [key for key in data.keys() if key not in hostnames_to_check]

        # 删除不匹配的主机名
        for key in keys_to_remove:
            del data[key]

        # 尝试获取锁
        # 检查文件是否存在，如果不存在则创建文件
        if not file_exists_with_timeout(lock_path):
            return

        # 将更新后的内容写回文件
        with open(file_path, 'w') as file:
            json.dump(data, file)
        print("File updated successfully.")
        os.remove(lock_path)

    except Exception as e:
        print(f"An error occurred: {e}")


def cat_virtual():
    api_key = "7vFw5cLEekRC8N2V_6u_AySH5cUAXyURF7bf65-hLaHZWy9z89nQ3eKSM1gPPUyglh4UDeCaj_wFKdejQa0cdg"
    secret_key = "r-kT7yxeYSdCoDzDTVc2kPLBL_Lzn4A6jLJs5giYIeWFgYCAI6tmreiTQQaXTzmjoPfQTkqHiCc0dZLBWgb2Lw"
    api_url = "http://cloud.gcgc168.net:8080/client/api"
    hostid = '28306bf2-9212-426e-bb46-5d40d6b04495'

    client = client_cloudstack(api_url, api_key, secret_key)
    get_cloudstack_virtual(client, hostid)


if __name__ == "__main__":
    cat_virtual()

